SystemOrganization addCategory: 'AbstractApplicationObjects'!

!String methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/09/2016 13:52'!
translateFor: userObject

	^self getInternationalization getTranslationFor: self in: userObject languageName! !

!String methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/09/2016 13:51'!
translateTo: languageName

	^self getInternationalization getTranslationFor: self in: languageName! !

Exception subclass: #AbstractApplicationException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

AbstractApplicationException subclass: #AppObjectAlreadyInCacheException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

AbstractApplicationException subclass: #AppObjectNotInCacheException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

AbstractApplicationException subclass: #NoApplicationException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

AbstractApplicationException subclass: #NoAppNameException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!Unicode16 methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/09/2016 13:54'!
translateFor: userObject

	^self getInternationalization getTranslationFor: self in: userObject languageName! !

Object subclass: #AbstractApplicationObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

AbstractApplicationObject subclass: #AbstractApplication
	instanceVariableNames: 'applicationName'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!AbstractApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:38'!
applicationNamed: aString
	"Answer a OrbeonApplication or BpmApplication named <aString> if none answer <nil>"

	^self applicationNamed: aString ifNone: [nil]! !

!AbstractApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:53'!
applicationNamed: aString ifNone: aBlock
	"Answer an OrbeonApplication or BpmApplication named <aString> if none evaluates the zero block argument <aBlock>"

	^self cache detect: [:each | each applicationName = aString] ifNone: aBlock! !

!AbstractApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:53'!
cache

	Cache ifNil: [self initializeCache].

	^Cache! !

!AbstractApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:53'!
hasApplicationNamed: aString
	"Answer whether or not the cache of the receiver has an instance named <app> as a string <aString>"

	^self cache anySatisfy: [:each | each applicationName = aString]! !

!AbstractApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:33'!
initializeCache

	Cache := Dictionary new.

	^Cache! !

!AbstractApplication class methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 13:23'!
newNamed: aString

	^super new initialize
		applicationName: aString;
		yourself! !

!AbstractApplication methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:53'!
addToCache
	"Add the receiver to the global cache that store instances of <BpmApplication> and <OrbeonApplication>.
	The receiver must have a name and the name can not be an empty <String>"

	applicationName ifNil: [^self throwExceptionNoApplicationName].
	applicationName isEmpty ifTrue: [^self throwExceptionNoApplicationName].

	(self cache includesKey: applicationName) ifTrue: [^self throwExceptionAlreadyInCache].

	^self cache at: applicationName put: self! !

!AbstractApplication methodsFor: 'Accessing' stamp: 'BrunoBB 02/08/2016 12:40'!
applicationName
	^applicationName! !

!AbstractApplication methodsFor: 'Updating' stamp: 'BrunoBB 02/08/2016 12:40'!
applicationName: newValue
	applicationName := newValue! !

!AbstractApplication methodsFor: 'other' stamp: 'BrunoBB 02/04/2016 10:08'!
cache

	^self class cache! !

!AbstractApplication methodsFor: 'other' stamp: 'BrunoBB 12/27/2015 12:16'!
removeFromCache

	applicationName ifNil: [^self throwExceptionNoApplicationName].
	applicationName isEmpty ifTrue: [^self throwExceptionNoApplicationName].

	(self cache includesKey: applicationName) ifFalse: [^self throwExceptionNotInCache].

	^self cache removeKey: applicationName! !

!AbstractApplication methodsFor: 'other' stamp: 'BrunoBB 12/27/2015 12:15'!
throwExceptionAlreadyInCache

	^AppObjectAlreadyInCacheException signal: 'The object is already in the global cache'! !

!AbstractApplication methodsFor: 'other' stamp: 'BrunoBB 12/27/2015 12:13'!
throwExceptionNoApplicationName

	^NoAppNameException signal: 'The application must have an application name'! !

!AbstractApplication methodsFor: 'other' stamp: 'BrunoBB 12/27/2015 12:17'!
throwExceptionNotInCache

	^AppObjectNotInCacheException signal: 'The Object is no in the cache'! !

AbstractApplicationObject subclass: #AppFieldValue
	instanceVariableNames: 'name value originalValue parentObject errorString format originalValueIsStObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

AppFieldValue subclass: #AppFieldBooelanValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!AppFieldBooelanValue class methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 12:13'!
stType

	^Boolean! !

!AppFieldBooelanValue methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:58'!
setValue: newValue
   "Modify the value of the instance variable 'value'."

	newValue ifNil: [^value := newValue].

	originalValueIsStObject ifTrue: [^value := newValue].

	[value := Boolean fromString: newValue] on: Error do:[:err | errorString := err description.].

	^value! !

AppFieldValue subclass: #AppFieldDateValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!AppFieldDateValue class methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 12:13'!
stType

	^Date! !

!AppFieldDateValue methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:58'!
setValue: newValue
   "Modify the value of the instance variable 'value'."

	newValue ifNil: [^value := newValue].

	originalValueIsStObject ifTrue: [^value := newValue].

	[value := Date fromMySqlString: newValue] on: Error do:[:err | errorString := err description.].

	^value! !

AppFieldValue subclass: #AppFieldNumberValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!AppFieldNumberValue class methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 12:13'!
stType

	^Number! !

!AppFieldNumberValue methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:58'!
setValue: newValue
   "Modify the value of the instance variable 'value'."

	newValue ifNil: [^value := newValue].

	originalValueIsStObject ifTrue: [^value := newValue].

	[value := Number readFrom: newValue] on: Error do:[:err | errorString := err description.].

	^value! !

AppFieldValue subclass: #AppFieldStringValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!AppFieldStringValue class methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 12:14'!
stType

	^String! !

!AppFieldStringValue methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 12:16'!
setValue: newValue

   "Modify the value of the instance variable 'value'."
   value := newValue! !

AppFieldValue subclass: #AppFieldTimeStampValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!AppFieldTimeStampValue class methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 12:14'!
stType

	^TimeStamp! !

!AppFieldTimeStampValue methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:58'!
setValue: newValue
   "Modify the value of the instance variable 'value'."

	newValue ifNil: [^value := newValue].

	originalValueIsStObject ifTrue: [^value := newValue].

	[value := TimeStamp fromMySqlString: newValue] on: Error do:[:err | errorString := err description.].

	^value! !

AppFieldValue subclass: #AppFieldTimeValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!AppFieldTimeValue class methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 12:15'!
stType

	^Time! !

!AppFieldTimeValue methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:58'!
setValue: newValue
   "Modify the value of the instance variable 'value'."

	newValue ifNil: [^value := newValue].

	originalValueIsStObject ifTrue: [^value := newValue].

	[value := Time fromMySqlString: newValue] on: Error do:[:err | errorString := err description.].

	^value! !

!AppFieldValue class methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:51'!
parentObject: anObject

	^super new initialize
		parentObject: anObject;
		yourself! !

!AppFieldValue class methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:51'!
parentObject: aObject name: stringName value: stringValue

	^self parentObject: aObject name: stringName value: stringValue originalValue: stringValue! !

!AppFieldValue class methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 13:00'!
parentObject: aObject name: stringName value: stringValue isStObject: aBoolean

	^self parentObject: aObject name: stringName value: stringValue originalValue: stringValue isStObject: aBoolean! !

!AppFieldValue class methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:51'!
parentObject: anObject name: stringName value: stringValue originalValue: originalValue

	^super new initialize
		parentObject: anObject;
		name: stringName;
		setValue: stringValue;
		originalValue: originalValue;
		yourself! !

!AppFieldValue class methodsFor: 'other' stamp: 'BrunoBB 02/23/2016 08:43'!
parentObject: anObject name: stringName value: stringValue originalValue: originalValue isStObject: aBoolean

	^super new initialize
		parentObject: anObject;
		name: stringName;
		originalValueIsStObject: aBoolean;
		setValue: stringValue;
		originalValue: originalValue;
		yourself! !

!AppFieldValue class methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:51'!
stType

	^self subclassResponsibility! !

!AppFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/16/2016 12:51'!
errorString
	^errorString! !

!AppFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/16/2016 12:51'!
errorString: newValue
	errorString := newValue! !

!AppFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/16/2016 12:51'!
format
	^format! !

!AppFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/16/2016 12:51'!
format: newValue
	format := newValue! !

!AppFieldValue methodsFor: 'other' stamp: 'BrunoBB 02/18/2016 11:56'!
getAssignment

	^parentObject assignment! !

!AppFieldValue methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:51'!
initialize

	super initialize.

	originalValueIsStObject := false! !

!AppFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/16/2016 12:51'!
name
	^name! !

!AppFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/16/2016 12:51'!
name: newValue
	name := newValue! !

!AppFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/16/2016 12:51'!
originalValue
	^originalValue! !

!AppFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/16/2016 12:51'!
originalValue: newValue
	originalValue := newValue! !

!AppFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/16/2016 12:51'!
originalValueIsStObject
	^originalValueIsStObject! !

!AppFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/16/2016 12:51'!
originalValueIsStObject: newValue
	originalValueIsStObject := newValue! !

!AppFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/16/2016 12:51'!
parentObject
	^parentObject! !

!AppFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/16/2016 12:51'!
parentObject: newValue
	parentObject := newValue! !

!AppFieldValue methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:51'!
printOn: aStream
	| tempValue |

	super printOn: aStream.

	tempValue := (originalValue class == String) ifTrue: [originalValue] ifFalse: [originalValue printString].
	
	aStream nextPutAll: '[', tempValue, ']'! !

!AppFieldValue methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 12:51'!
setValue: newValue

	self subclassResponsibility! !

!AppFieldValue methodsFor: 'Accessing' stamp: 'BrunoBB 02/16/2016 12:51'!
value
	^value! !

!AppFieldValue methodsFor: 'Updating' stamp: 'BrunoBB 02/16/2016 12:51'!
value: newValue
	value := newValue! !

AbstractApplicationObject subclass: #AppFieldValueHolder
	instanceVariableNames: 'fieldName currentValues toAdd toRemove alreadyAddedToFormDefinition alreadyAddedToProcessDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!AppFieldValueHolder class methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:51'!
forFieldNamed: aString

	^super new initialize
		fieldName: aString;
		yourself! !

!AppFieldValueHolder methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:51'!
alreadyAddedToFormDefinition
	^alreadyAddedToFormDefinition! !

!AppFieldValueHolder methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:51'!
alreadyAddedToFormDefinition: newValue
	alreadyAddedToFormDefinition := newValue! !

!AppFieldValueHolder methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:51'!
alreadyAddedToProcessDefinition
	^alreadyAddedToProcessDefinition! !

!AppFieldValueHolder methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:51'!
alreadyAddedToProcessDefinition: newValue
	alreadyAddedToProcessDefinition := newValue! !

!AppFieldValueHolder methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:51'!
currentValues
	^currentValues! !

!AppFieldValueHolder methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:51'!
currentValues: newValue
	currentValues := newValue! !

!AppFieldValueHolder methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:51'!
fieldName
	^fieldName! !

!AppFieldValueHolder methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:51'!
fieldName: newValue
	fieldName := newValue! !

!AppFieldValueHolder methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:51'!
fieldsToAddDo: aBlock

	^toAdd do: aBlock! !

!AppFieldValueHolder methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:51'!
fieldsToRemoveDo: aBlock

	^toRemove do: aBlock! !

!AppFieldValueHolder methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:51'!
hasElementsToAdd

	^toAdd notEmpty! !

!AppFieldValueHolder methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:51'!
hasElementsToRemove

	^toRemove notEmpty! !

!AppFieldValueHolder methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:51'!
initialize

	super initialize.

	currentValues := OrderedCollection new.
	toAdd := OrderedCollection new.
	toRemove := OrderedCollection new.
	alreadyAddedToFormDefinition := false.
	alreadyAddedToProcessDefinition := false.
" 
fieldName			- name of the field that the receiver is holding.
currentValues		- a collection of FormFieldValue with the current values of the form.
toAdd 				- elements added in this edition. (if NOT empty --> <toRemove> is empty)
toRemove			- elements removed in this edition. (if NOT empty --> <toAdd> is empty)
alreadyProcessed	- whether or not the receiver has been processed. 
"! !

!AppFieldValueHolder methodsFor: 'other' stamp: 'BrunoBB 02/16/2016 13:06'!
processFieldValueCollection: fieldValueCollection withFieldClass: formFieldValueClass in: anOrbeonFormInstance
	"The receiver create/update the values of the field that it represent where the new values are in <fieldValueCollection> and belongs to the form <anOrbeonFormInstance> and the type of the field is <formFieldValueClass>.
	[values creation] *  if <currentValues> is empty --> create the values for the first time (never enter again -only if the values are removed from the form and <currentValues>- becomes empty again).
	[values update] * if current and new values is equal in size --> update values.
	if not --> add/remove elements so current and new values are equal in size again --> update values"
 
	^self processFieldValueCollection: fieldValueCollection 
			withFieldClass: formFieldValueClass 
			in: anOrbeonFormInstance 
			isStObject: false! !

!AppFieldValueHolder methodsFor: 'other' stamp: 'BrunoBB 02/23/2016 08:59'!
processFieldValueCollection: fieldValueCollection withFieldClass: formFieldValueClass in: anOrbeonFormInstance isStObject: aBoolean
	"The receiver create/update the values of the field that it represent where the new values are in <fieldValueCollection> and belongs to the form <anOrbeonFormInstance> and the type of the field is <formFieldValueClass>.
	[values creation] *  if <currentValues> is empty --> create the values for the first time (never enter again -only if the values are removed from the form and <currentValues>- becomes empty again).
	[values update] * if current and new values is equal in size --> update values.
	if not --> add/remove elements so current and new values are equal in size again --> update values"
 
	toAdd := OrderedCollection new. 
	toRemove := OrderedCollection new.

	currentValues isEmpty "first time the values are processed (never processed before)"
	ifTrue: [^fieldValueCollection do: [:eachValue | | fieldValue |
					fieldValue := formFieldValueClass parentObject: anOrbeonFormInstance name: fieldName value: eachValue isStObject: aBoolean. "Create aAppFieldValue"
					currentValues add: fieldValue]
	].

	"we only need to update current values with the newones in <fieldValueCollection>"
	(currentValues size = fieldValueCollection size) 
	ifTrue: [^self updateEqualCurrentFieldValuesWith: fieldValueCollection].

	"we have to remove some objects <FormFieldValue> and then update current values"
	(currentValues size > fieldValueCollection size) 
	ifTrue: [^self updateAndRemoveCurrentFieldValuesWith: fieldValueCollection].

	"we have to add some objects <FormFieldValue> and the update current values"
	(currentValues size < fieldValueCollection size) 
	ifTrue: [^self updateAndAddCurrentFieldValuesWith: fieldValueCollection fieldClass: formFieldValueClass form: anOrbeonFormInstance].! !

!AppFieldValueHolder methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:51'!
toAdd
	^toAdd! !

!AppFieldValueHolder methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:51'!
toAdd: newValue
	toAdd := newValue! !

!AppFieldValueHolder methodsFor: 'Accessing' stamp: 'BrunoBB 02/11/2016 11:51'!
toRemove
	^toRemove! !

!AppFieldValueHolder methodsFor: 'Updating' stamp: 'BrunoBB 02/11/2016 11:51'!
toRemove: newValue
	toRemove := newValue! !

!AppFieldValueHolder methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:51'!
updateAndAddCurrentFieldValuesWith: fieldValueCollection fieldClass: formFieldValueClass form: anOrbeonFormInstance
	"[currentValues size < fieldValueCollection size]
	Field Values in the form has been add --> we have to create and add FormFieldValues to the <currentValues> collection.
	Then we have to add these new object <FormFieldValue> to the OrbeonFormProcessDefinition index collection.
	To do this we add these object to <toAdd> collection to be added later."

	"create the new neccesary objects with class type <formFieldValueClass> and add it to <toAdd> and <currentValues>"
	1 to: (fieldValueCollection size - currentValues size) do:[:index | | newFormFieldValue | 
		newFormFieldValue := formFieldValueClass parentObject: anOrbeonFormInstance name: fieldName value: nil.
		toAdd add: newFormFieldValue.
		currentValues add: newFormFieldValue].

	self updateEqualCurrentFieldValuesWith: fieldValueCollection. "update FormFieldValues"! !

!AppFieldValueHolder methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:51'!
updateAndRemoveCurrentFieldValuesWith: fieldValueCollection
	"[currentValues size > fieldValueCollection size].
	Field Values in the form has been removed --> remove these leftover fields from the OrbeonFormProcessDefinition index collection.
	To do this we add these object to <toRemove> collection to be removed later."

	toRemove := currentValues copyFrom: (fieldValueCollection size + 1) to: currentValues size. "elements to remove"

	currentValues :=  fieldValueCollection isEmpty 
		ifTrue: [OrderedCollection new] "if the new collection of value is empty --> all elements has been removed --> currentValues is empty"
		ifFalse: [currentValues copyFrom: 1 to: fieldValueCollection size.]. "collection with only <fieldValueCollection> elements"
	 

	self updateEqualCurrentFieldValuesWith: fieldValueCollection. "update FormFieldValues"! !

!AppFieldValueHolder methodsFor: 'other' stamp: 'BrunoBB 02/11/2016 11:51'!
updateEqualCurrentFieldValuesWith: fieldValueCollection
	"[fieldValueCollection size = currentValues size]
	Iterate over new values collection <fieldValueCollection> and set the corresponding values (with it's type) on <currentValues>.
	This will cause and index reorganization in the OrbeonFormProcessDefinition collection."

	fieldValueCollection keysAndValuesDo: [:index :stringValue | (currentValues at: index) setValue: stringValue].! !

AbstractApplicationObject subclass: #ApplicationInternationalization
	instanceVariableNames: 'languagesDictionaries'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!ApplicationInternationalization class methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:42'!
default

	Default ifNil: [Default := super new initialize].

	^Default! !

!ApplicationInternationalization methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:43'!
addLanguage: symbolName

	^languagesDictionaries at: symbolName put: Dictionary new! !

!ApplicationInternationalization methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:43'!
currentDictionaries

	^languagesDictionaries keys asSortedCollection! !

!ApplicationInternationalization methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:43'!
englishTranslations

	^languagesDictionaries at: #english! !

!ApplicationInternationalization methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:43'!
getTranslationFor: aString in: languageName

	^(languagesDictionaries at: languageName ifAbsent: [^aString])
			at: aString asString ifAbsent: [aString]! !

!ApplicationInternationalization methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:43'!
getTranslationsOf: languageName

	^languagesDictionaries at: languageName ifAbsent: [Dictionary new]! !

!ApplicationInternationalization methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:43'!
includesTranslationFor: aString in: languageName

	^(languagesDictionaries at: languageName ifAbsent: [^false])
			includesKey: aString! !

!ApplicationInternationalization methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:43'!
initialize

	super initialize.

	languagesDictionaries := Dictionary new.! !

!ApplicationInternationalization methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:43'!
initializeEnglish

	languagesDictionaries at: #english put: Dictionary new! !

!ApplicationInternationalization methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:43'!
initializeSpanish

	languagesDictionaries at: #spanish put: Dictionary new! !

!ApplicationInternationalization methodsFor: 'Accessing' stamp: 'BrunoBB 02/09/2016 13:44'!
languagesDictionaries
	^languagesDictionaries! !

!ApplicationInternationalization methodsFor: 'Updating' stamp: 'BrunoBB 02/09/2016 13:44'!
languagesDictionaries: newValue
	languagesDictionaries := newValue! !

!ApplicationInternationalization methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:43'!
spanishTranslations

	^languagesDictionaries at: #spanish! !

!ApplicationInternationalization methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:43'!
translate: stringKey as: translatedString for: languageName

	^(languagesDictionaries at: languageName ifAbsent: [^stringKey])
			at: stringKey asString put: translatedString! !

AbstractApplicationObject subclass: #ApplicationServerConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

ApplicationServerConfiguration class
	instanceVariableNames: 'default'!

!ApplicationServerConfiguration class methodsFor: 'Accessing' stamp: 'BrunoBB 02/03/2016 08:52'!
default

	default ifNil: [default := super new initialize].

	^default! !

!ApplicationServerConfiguration class methodsFor: 'Updating' stamp: 'BrunoBB 02/03/2016 08:51'!
default: newValue
	default := newValue! !

ApplicationServerConfiguration subclass: #GemStoneServerConfiguration
	instanceVariableNames: 'gemstoneIP loginModes'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!GemStoneServerConfiguration methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:15'!
bindPasswordForWebOrbeon

	^(loginModes at: 'orbeon-web') bindPassword! !

!GemStoneServerConfiguration methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:15'!
bindPasswordForWebProcess

	^(loginModes at: 'orbeon-processes-web') bindPassword! !

!GemStoneServerConfiguration methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:15'!
dnForWebOrbeon

	^(loginModes at: 'orbeon-web') dn! !

!GemStoneServerConfiguration methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:15'!
dnForWebProcess

	^(loginModes at: 'orbeon-processes-web') dn! !

!GemStoneServerConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 02/02/2016 20:16'!
gemstoneIP
	^gemstoneIP! !

!GemStoneServerConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 02/02/2016 20:16'!
gemstoneIP: newValue
	gemstoneIP := newValue! !

!GemStoneServerConfiguration methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:14'!
initialize

	super initialize.

	loginModes := Dictionary new.

	"Intitally we set the user as Local not in LDAP"
	self setLocalForOrbeon.
	self setLocalForProcesses.! !

!GemStoneServerConfiguration methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:15'!
ldapIpForWebOrbeon

	^(loginModes at: 'orbeon-web') ldapIP! !

!GemStoneServerConfiguration methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:15'!
ldapIpForWebProcess

	^(loginModes at: 'orbeon-processes-web') ldapIP! !

!GemStoneServerConfiguration methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:15'!
loginModeFor: webAppName

	^loginModes at: webAppName ifAbsent: [nil]! !

!GemStoneServerConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 02/02/2016 20:16'!
loginModes
	^loginModes! !

!GemStoneServerConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 02/02/2016 20:16'!
loginModes: newValue
	loginModes := newValue! !

!GemStoneServerConfiguration methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:15'!
ouForWebOrbeon

	^(loginModes at: 'orbeon-web') ou! !

!GemStoneServerConfiguration methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:15'!
ouForWebProcess

	^(loginModes at: 'orbeon-processes-web') ou! !

ApplicationServerConfiguration subclass: #OrbeonDatabaseConfiguration
	instanceVariableNames: 'databaseIP databaseUser databasePassword'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!OrbeonDatabaseConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 02/03/2016 08:52'!
databaseIP
	^databaseIP! !

!OrbeonDatabaseConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 02/03/2016 08:52'!
databaseIP: newValue
	databaseIP := newValue! !

!OrbeonDatabaseConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 02/03/2016 08:52'!
databasePassword
	^databasePassword! !

!OrbeonDatabaseConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 02/03/2016 08:52'!
databasePassword: newValue
	databasePassword := newValue! !

!OrbeonDatabaseConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 02/03/2016 08:52'!
databaseUser
	^databaseUser! !

!OrbeonDatabaseConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 02/03/2016 08:52'!
databaseUser: newValue
	databaseUser := newValue! !

ApplicationServerConfiguration subclass: #OrbeonServerConfiguration
	instanceVariableNames: 'orbeonIP'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!OrbeonServerConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 02/03/2016 10:07'!
orbeonIP
	^orbeonIP! !

!OrbeonServerConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 02/03/2016 10:07'!
orbeonIP: newValue
	orbeonIP := newValue! !

AbstractApplicationObject subclass: #ApplicationUser
	instanceVariableNames: 'username password'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'AbstractApplicationObjects'!

!ApplicationUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:16'!
cache

	Cache ifNil: [self initializeCache].

	^Cache! !

!ApplicationUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:37'!
getExistingOrNewUserNamed: aString

	^(self getUserNamed: aString) 
		ifNil: [(self newUserNamed: aString password: '') addToCache; yourself]
		ifNotNil: [:user | user]! !

!ApplicationUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:17'!
getUserNamed: aString

	^self cache at: aString ifAbsent: [nil]! !

!ApplicationUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:16'!
initializeCache

	Cache := Dictionary new.! !

!ApplicationUser class methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:26'!
newUserNamed: aString password: pwd

	^super new initialize
		username: aString;
		password: pwd;
		yourself! !

!ApplicationUser methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 11:18'!
addToCache

	^self class cache at: username put: self! !

!ApplicationUser methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 11:16'!
password
	^password! !

!ApplicationUser methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 11:16'!
password: newValue
	password := newValue! !

!ApplicationUser methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 11:16'!
username
	^username! !

!ApplicationUser methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 11:16'!
username: newValue
	username := newValue! !

!Object class methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/08/2016 13:26'!
getApplicationManagerClass
	"The receiver answer the class used as applications manager"

	^AbstractApplication! !

!Object class methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/09/2016 13:18'!
getApplicationsCache
	"The receiver answer a collection with all applications"

	^self getApplicationManagerClass cache! !

!Object class methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/03/2016 09:22'!
getGemStoneServerConfiguration

	^GemStoneServerConfiguration default! !

!Object class methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/09/2016 13:46'!
getInternationalization
	"Answer the object instance that handle internationalization for WEB applications"

	^ApplicationInternationalization default! !

!Object class methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/03/2016 08:53'!
getOrbeonDatabaseConfiguration

	^OrbeonDatabaseConfiguration default! !

!Object class methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/03/2016 10:07'!
getOrbeonWebServerConfiguration

	^OrbeonServerConfiguration default! !

!Object methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/08/2016 13:25'!
getApplicationManagerClass
	"The receiver answer the class used as applications manager"

	^self class getApplicationManagerClass! !

!Object methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/09/2016 13:17'!
getApplicationsCache
	"The receiver answer a collection with all applications"

	^self class getApplicationsCache! !

!Object methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/03/2016 09:23'!
getGemStoneServerConfiguration

	^self class getGemStoneServerConfiguration! !

!Object methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/09/2016 13:47'!
getInternationalization
	"Answer the object instance that handle internationalization for WEB applications"

	^self class getInternationalization! !

!Object methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/03/2016 08:53'!
getOrbeonDatabaseConfiguration

	^self class getOrbeonDatabaseConfiguration! !

!Object methodsFor: '*abstractApplicationObjects' stamp: 'BrunoBB 02/03/2016 08:44'!
getOrbeonWebServerConfiguration

	^self class getOrbeonWebServerConfiguration! !
